unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, PtblRV, RVUniscribeGrIn,
  RVStyle, RVScroll, RichView, RVEdit, RVWinGrIn;

type
  TForm1 = class(TForm)
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    RichViewEdit2: TRichViewEdit;
    RVPrint1: TRVPrint;
    Button1: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  RVFieldItems, SynPDF, Winapi.ShellAPI;

procedure TForm1.Button1Click(Sender: TObject);
begin
  var Doc := TPdfDocumentGDI.Create;
  Doc.PDFA1 := True;
  Doc.ScreenLogPixels := Screen.PixelsPerInch;
  Doc.DefaultPaperSize := psA4;
  Doc.DefaultPageLandscape := False;
  Doc.AddPage;

  var canvas := Doc.VCLCanvas;

  if CheckBox1.Checked then
    RVStyle1.TextEngine := rvteUniscribe
  else
    RVStyle1.TextEngine := rvteWindows;

  if CheckBox2.Checked then
    RVPrint1.MetafileCompatibility := True
  else
    RVPrint1.MetafileCompatibility := False;

  RVPrint1.SetFooter(RichViewEdit2.RVData);
  RVPrint1.AssignSource(RichViewEdit1);
  RVPrint1.VirtualPrinter.Active := True;
  RVPrint1.VirtualPrinter.PageWidth := Doc.VCLCanvasSize.Width;
  RVPrint1.VirtualPrinter.PageHeight := Doc.VCLCanvasSize.Height;
  RVPrint1.FormatPages(rvdoALL);
  RVPrint1.DrawPage(1, canvas, False);

  Doc.SaveToFile('Sample.PDF');
  Doc.Free;
  ShellExecute(0, 'open', 'Sample.PDF', nil, nil, SW_SHOW);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  FontText, FontBold, FontBoldU, FontSmall, FontSmalli, FontExec: Integer;
  ParaText, ParaCenter, ParaPre: Integer;
begin
  var FI := TFontInfo.Create(nil);

  FI.FontName := 'Arial';
  FI.Size := 10;
  FI.Color := clWindowText;
  FontText := RVStyle1.FindTextStyle(FI);
  FI.Size := 9;
  FI.Style := [fsBold];
  FI.Color := clBlack;
  FontBold := RVStyle1.FindTextStyle(FI);
  FI.Style := [fsBold, TFontStyle.fsUnderline];
  FontBoldU := RVStyle1.FindTextStyle(FI);
  FI.Size := 8;
  FI.Style := [];
  FontSmall := RVStyle1.FindTextStyle(FI);
  FI.Style := [fsItalic];
  FontSmalli := RVStyle1.FindTextStyle(FI);

  FI.FontName := 'Courier New';
  FI.Style := [];
  FI.Color := clRed;
  FontExec := RVStyle1.FindTextStyle(FI);

  FI.Free;

  var PI := TParaInfo.Create(nil);
  PI.Alignment := rvaLeft;
  ParaText := RVStyle1.FindParaStyle(PI);
  PI.Alignment := rvaCenter;
  ParaCenter := RVStyle1.FindParaStyle(PI);
  PI.Alignment := rvaLeft;
  PI.Options := PI.Options + [rvpaoNoWrap];
  ParaPre := RVStyle1.FindParaStyle(PI);
  PI.Free;

  RichViewEdit1.Clear;
  RichViewEdit1.RVData.AddNL('Some text', FontText, ParaText);
  RichViewEdit1.RVData.AddNL(' ', FontText);
  RichViewEdit1.RVData.AddNL('Some text', FontBoldU);
  RichViewEdit1.Format();

  RichViewEdit2.Clear;
  RichViewEdit2.RVData.AddNL('Page ', FontSmall, ParaCenter);
  var P := TRVPageNumberItemInfo.Create(RichViewEdit2.RVData);
  P.TextStyleNo := FontSmall;
  P.ParaNo := -1;
  RichViewEdit2.RVData.AddItem('', P);
  RichViewEdit2.RVData.AddNL('/', FontSmall);
  var N := TRVPageCountItemInfo.Create(RichViewEdit2.RVData);
  N.TextStyleNo := FontSmall;
  N.ParaNo := -1;
  RichViewEdit2.RVData.AddItem('', n);
  RichViewEdit2.Format();
end;

end.
